/* -*- linux-c -*- */
/**
 * 信号の定義
 *
 * (c) 2013-2014 Kunihiko Imai <bak@d2.dion.ne.jp>
 * All rights reserved.
 *
 */
#ifndef __SIGNAL_SPEC_H__
#define __SIGNAL_SPEC_H__

#define F_MARK 1024  /**< マーク周波数[Hz]*/
#define F_SPACE 640  /**< スペース周波数[Hz] */

#define BPS 64 /**< ビットレート [bps] */

#define Fs 8000 /**< サンプリング周波数 [Hz] */

/* マーク周期・スペース周期検出の上限・下限 */
#define T_MARK_H (1.0/(F_MARK - 192)) 
#define T_MARK_L (1.0/(F_MARK + 192))
#define T_SPACE_H (1.0/(F_SPACE - 192))
#define T_SPACE_L (1.0/(F_SPACE + 192))

#define T_BPS (1.0/BPS)		/**< 1符号の周期 [s] */
#define N_BPS ((int)(Fs/BPS))	/**< １符号のサンプル数 */

enum {
	MARK = '1',   /**< マーク検出 */
	SPACE = '0',  /**< スペース検出 */
	NONE = 'N',   /**< 無検出状態 */

	NUL = '\0',   /**< 何者でもない */
};

enum {
	A_MARK = 1,   /**< マーク検出 */
	A_SPACE = -1,  /**< スペース検出 */
	A_NONE = 0,   /**< 無検出状態 */

	A_NUL = 99999,   /**< 何者でもない */
};
#endif
